.MODEL SMALL
.STACK 100H
.286

;
; GROUP DEFINATION 
;

	DGROUP GROUP DRIVER
	DGROUP GROUP MYDATA
	ASSUME DS:DGROUP , CS:DGROUP
	
;
; DEVICE DRIVER VIRTUAL SEGMENT 
;
DRIVER SEGMENT 'CODE'

		;۱۱۱۱۱۱۱DEVICE DRIVER HEADER۱۱۱۱۱۱
		DD -1				; NEXT DEVICE
		;  FEDCBA9876543210
		DW 0010100000000000B		; ATTRB WORD
		DW STRATEGY			; FPTR TO STR FUNC
		DW INTERRUPT			; FPTR TO INT FUNC
		DB 1				; # BLOCK DEVICES
		DB 7 DUP (0)			; UN USED
			
		INCLUDE FISA_DRV.H	; MACROS & EQUATES			

;
; STRATEGY PROCEDURE 
;
STRATEGY PROC 
	MOV WORD PTR CS:REQPTR+0,BX	;SAVE REQUAST HEADER
	MOV WORD PTR CS:REQPTR+2,ES
	RETF
STRATEGY ENDP	

;
; INTERRUPT PROCEDURE 
;
INTERRUPT PROC
	PUSH AX
	CLI
	MOV WORD PTR CS:CALLER_STACK+0,SP
	MOV WORD PTR CS:CALLER_STACK+2,SS
	MOV AX,CS
	LEA SP,LOCAL_STACK
	MOV SS,AX
	STI

	PUSHA
	LDS BX,CS:[REQPTR]
	MOV AL,[BX+CMDC]
	CMP AL,15
	JA CMDERR
	CBW 
	SHL AX,1
	MOV SI,OFFSET FNPTR
	ADD SI,AX
	MOV AX,CS:[SI]
	JMP AX

INTERRUPT ENDP

;
; SEARCH & LOAD THE BOOT SECTOR OF BAD FLOPPY 
;
LOAD_SECTMAP PROC
	PUSH CS
	PUSH CS
	POP  DS
	POP  ES
	MOV DSK_BOOT,9		; ASSUME 9TH  ONE IS BOOT SECTOR

BB1:	DOS2BIOS DSK_BOOT , 18	; CONVERT LOGICAL SECTOR TO TRK+HEAD+SECT
	LEA BX,BOOT_BUFF	; LOACAL BOOT SECTOR BUFFER 
	MOV AX,0201H		; ASSUMING 1.44 DISK BUT IT MAY NOT
	MOV DL,CS:PH_DISK
	INT 13H
	JNC BB4
	CMP AH,06H
	JZ BB1
	CMP AH,02H
	JZ BB3
	CMP AH,04H
	JZ BB3
	CMP AH,10H
	JZ BB3
	RET
		
BB4:	LEA BX,BOOT_BUFF
	LEA SI,DGROUP:SGN_STR		; IS BOOT HAS SIGNATURE STRINGS
	LEA DI,BOOTS:SGN_STR
	ADD DI,BX
	MOV CX,SGN_LEN
	CLD
	REPE CMPSB
	JZ BB2
	
BB3:	INC DSK_BOOT			; MAY BE NEXT SECT WILL BE BOOT
	CMP DSK_BOOT,72			; IS SEARCH COMES TO SECT # 72
	JBE BB1				; ONLY 72 BECAUSE OF PERFORMANCE
	RET				; BUT CAN BE INCREASE

BB2:	MOV CS:IS_VALID_BUFF,55H	; FOUND VALID BOOT SECTOR
					; SET IS_VALID_BUFF TO TRUE (!0)
					; NOW LOCAL BOOT BUFF CONTAINIG
					; VALID BPB & SECTOR MAP
	LEA BX,BOOT_BUFF
	LEA SI,BOOTS:S_TRK
	MOV AX,[SI + BX ]
	MOV S_TRK,AX			; SAVE IT TO IDLE BOOT SECTOR
	LEA SI,BOOTS:DIRS
	MOV AX,[SI  + BX]		; DIR  ENTRIES	
	MOV CL,4			; NUMBER SECTOR REQUIRED
	SHR AX,CL			; ENTRIES / 16 = SECTORS
	LEA SI,BOOTS:S_FAT
	ADD AX,[SI + BX]		; ADD TO AX  ( FAT1 SECTORS )
	ADD AX,[SI + BX]		; ADD TO AX  ( FAT2 SECTORS )
	INC AX				; AX= TOTAL SYSTEM SECTORS
	MOV SYS_SECT,AX			; SAVE IT TO IDLE BOOT SECTOR
	RET
	
LOAD_SECTMAP ENDP

;
; FUNCTIONS THAT WILL GET CONTROL FROM INTERRUPT PROCEDURE 
;

;
; EXIT POINT OF INTERRUPT PROCEDURE
;
CMDERR:	MOV AL,3			; UNKNOWN COMMAND 
_ERR2:	MOV AH,10000001B		; SET ERROR & DONE FLAG	
	JMP GOBACK
EXIT:	MOV AL,3			; THIS WILL NOT CONSIDERE
	MOV AH,1			; SET DONE FLAG
GOBACK:	MOV WORD PTR [BX+STAT],AX	; MOV STATUS WORD TO REQ HEADER
	POPA
	CLI
	MOV AX,WORD PTR CS:CALLER_STACK+2
	MOV SP,WORD PTR CS:CALLER_STACK+0
	MOV SS,AX
	STI
	POP AX
	RETF
	

;
; IS MEDIA IN DRIVE CHANGE ? 
;
MEDIA_CHK:
	CMP CS:IS_M_CH,0
	JZ M_IS_CH
	PUSH BX
	MOV CX,CS:LAST_ACSS+0
	MOV DX,CS:LAST_ACSS+2
	MOV DL,CS:PH_DISK
	MOV AX,0401H
	INT 13H
	POP BX
	CMP CS:IS_M_CH,0
	JZ M_IS_CH
	MOV BYTE PTR [BX+14],1	
	JMP EXIT
M_IS_CH:
	LEA AX,PR_VOL_ID
	MOV [BX+15],AX
	MOV [BX+17],CS
	MOV BYTE PTR [BX+14],-1	
	JMP EXIT

;
; BUILD BIOS PARAMETER BLOCK 
;
BUILDBPB:
	CMP CS:IS_VALID_BUFF,0		; IS BUFF CONATINING VALID DATA
	JNZ BOK
	CALL LOAD_SECTMAP		; VALIDATE THE LOCAL BOOT BUFF
	LDS  BX,CS:REQPTR
	CMP CS:IS_VALID_BUFF,0		; IS BUFF CONATINING VALID DATA
	JNZ BOK	
	MOV AL,0CH			; ERROR:- INVALID DISK IN DRIVE
	JMP _ERR2
BOK:
	LEA AX,BOOTS:NBYTES		; MEDIA IN DRIVE, {TO MEDIA CHANGE}
	LEA CX,BOOT_BUFF
	ADD AX,CX
	MOV [BX+18],AX			; SET PTR TO NEW BPB
	MOV [BX+20],CS
	MOV CS:IS_M_CH,55H
	JMP EXIT

;
; READ / WRITE LOGICAL BLOCK 
;
MOVE_BLOCK PROC
	CMP WORD PTR [BX+COUNT],0	; # SECT MUST BE NON ZERO 
	JZ CMDERR			; INVALID COMMAND

	CMP CS:IS_VALID_BUFF,0		; IS BUFF CONATINING VALID DATA
	JNZ VOK_
	CALL LOAD_SECTMAP		; VALIDATE THE LOCAL BOOT BUFF
	LDS BX,CS:REQPTR		
	CMP CS:IS_VALID_BUFF,0		; IS BUFF CONATINING VALID DATA
	JNZ VOK_		
	MOV AL,0CH			; ERROR:- INVALID DISK IN DRIVE
	JMP _ERR2

VOK_:	MOV SI,BX
	MOV BX,[SI+START]		; GET STARTING SECTOR NUMBER
	CMP BX,CS:SYS_SECT		; IS IN SYSTEM AREA
	JAE CN1

	LEA DI,BOOTS:SECTMAP		; YES IN SYSTEM AREA, SO USE
	LEA AX,BOOT_BUFF		; SECTOR MAP IN LOCAL BUFF
	ADD DI,AX			; TO LOCATE THE ACTUAL SECTOR
	ADD DI,BX
	ADD DI,BX
	MOV CX,[SI+COUNT]		; GET # SECTOR TO MOVE
	MOV WORD PTR [SI+COUNT],0	; SET MOVED = 0
	LES BX,[SI+TRNS]		; GET PTR TO CALLER BUFFER

_CHAIN:					; READ SECTORS ONE BY ONE
					; WITH THE HELP OF SECTOR MAP
	PUSH CX
	PUSH SI
	PUSH DI
	PUSH BX

	MOV CX,CS:[DI]			; GET MAPED SECTOR #
	MOV BX,[SI+START]
	ADD BX,[SI+COUNT]		; GOING TO READ SECTOR #
	CMP BX,CS:SYS_SECT		; IS STILL IN SYSTEM AREA
	JB S_AREA	
	SUB BX,CS:SYS_SECT		; SINCE IT DATA SECTOR THERE FORE
	LEA DI,BOOTS:SECTMAP		; SUBTRACT NUMBER OF SYSTEM SECTOR
	LEA AX,BOOT_BUFF		; ADDRES TO SECTOR WORD MAP
	ADD DI,AX
	ADD DI,CS:SYS_SECT		; ADRESS TO FISRT DATA SECTOR NUM
	ADD DI,CS:SYS_SECT		
	
	ADD BX,CS:[DI]			; ORIGNAL SECTOR NUMBER
	MOV CX,BX		

S_AREA:	DOS2BIOS CX , CS:S_TRK		; LINEAR  TO TRK+HEAD+SECT
	POP BX
	PUSH BX				; OFFSET PTR TO CALLER BUFF
	MOV DL,CS:PH_DISK
	MOV AL,1
	CMP BYTE PTR [SI+CMDC],4	; READ OR WRITE ?
	JNZ _WR_
	MOV AH,02H			; READ OPERATION
	JMP _RD_
_WR_:	MOV AH,03H			; WRITE OPERATION
_RD_:   CALL BIOS13
	JC N_OK_
	
	POP BX
	POP DI
	POP SI
	INC WORD PTR [SI+COUNT]		; ONE MORE SECTOR MOVED 
	ADD DI,2			; PTR TO NEXT MAPED SECTOR
	MOV AX,ES
	ADD AX,20H			; ES + ( 512 / 16 )
	MOV ES,AX			; PTR TO NEXT SECTOR
	POP CX
	LOOP _CHAIN
	MOV AL,3
	MOV AH,00000001B		; SET NO ERROR FLAG
_DONE_:	
	MOV BX,SI
	JMP GOBACK			; END THE DISK IO

N_OK_:
	POP BX
	POP DI
	POP SI
	POP CX

	MOV AL,04			; CRC ERROR
	MOV AH,10000001B		; SET ERROR FLAG
	JMP _DONE_			; END THE DISK IO
	
;	
;	۱۱ IF REQUESTED SECTOR NOT IN SYSTEM AREA ۱۱۱
;	
CN1:	SUB BX,CS:SYS_SECT		; SUBTRACT NUMBER OF SYSTEM SECTORS
	LEA DI,BOOTS:SECTMAP		; ADDRESS TO SECTOR WORD MAP
	LEA AX,BOOT_BUFF
	ADD DI,AX
	ADD DI,CS:SYS_SECT		; ADDRES TO FIRST DATA SECTOR NUM
	ADD DI,CS:SYS_SECT
	
	ADD BX,CS:[DI]			; ADD 1st MAPED DATA SECTOR
	MOV DI,[SI+COUNT]
	MOV WORD PTR [SI+COUNT],0
	LES CX,[SI+TRNS]		; TRANSFER ADDRESS
	XCHG BX,CX

CN3:	PUSH CX
	PUSH BX
	DOS2BIOS CX , CS:S_TRK		; LINEAR TO TRK+HEAD+SECT
	MOV AX,CS:S_TRK			; SECTOR PER SIDE
	INC AX				
	SUB AL,CL			; SECTOR CAN BE MOVE IN THIS ITRATION
	
	CMP DI,AX			; IS REQUIRED <= CAPACITY
	JBE S_ACS
	SUB DI,AX			; MOVE CALCUTED FOR ITRATION
	JMP DO_AC			; SUBTRACT THEM FROM REQUIRED

S_ACS:	MOV AX,DI			; IF REQUIRED <= CAPACITY
	XOR DI,DI			; ALL DONE ( DI = 0 )

DO_AC:	POP BX				; BX= TRANSFER ADDRESS
	PUSH BX
	PUSH AX				; AL = SECTORS TO MOVE
	PUSH SI
	PUSH DI
	MOV DL,CS:PH_DISK
	CMP BYTE PTR [SI+CMDC],4	; READ OR WRITE
	JNZ WRITE
	MOV AH,02H			; READ
	JMP KILK2
WRITE:	MOV AH,03H			; WRITE
KILK2:	CALL BIOS13
	JNC AC_OK
	
	POP DI
	POP SI
	POP AX
	POP BX
	POP CX
	MOV AL,04			; CRC ERROR
	MOV AH,10000001B		; SET ERROR FLAG
	JMP _DONE_			; END THE DISK IO

AC_OK:
	POP DI
	POP SI
	POP AX
	POP BX
	POP CX
	XOR AH,AH
	ADD [SI+COUNT],AX		; INCREASE MOVED SECTORS
	ADD CX,AX			; INCREASE THE SECTOR NUMBER
	PUSH CX
	MOV CL,5
	SHL AX,CL			; AX = AX * ( 512 / 16 )
	MOV CX,ES			; INCREASE THE TRANSFER ADDRES
	ADD AX,CX			; BY ABOVE FORMULA, WHERE
	MOV ES,AX			; INITIAL AX=NUMBER SECT MOVED.
	POP CX
	CMP DI,0			; IS ALL DONE 
	JNZ CN3				; NO MOVE REST
		
	MOV AL,3
	MOV AH,00000001B		; SET NO ERROR FLAG
	MOV BX,SI
	JMP GOBACK			; END THE DISK IO
	
MOVE_BLOCK ENDP

;
; INITIALIZATION PROCEDURE CALLED ONLY ONCE 
;
INIT:
	XOR AX,AX
	MOV DS,AX
	MOV AX,DS:[ (4*14) + 0  ]		; SAVE CURRENT INT 0EH
	MOV WORD PTR CS:OLD_ISR_0E + 0 , AX
	MOV AX,DS:[ (4*14) + 2  ]
	MOV WORD PTR CS:OLD_ISR_0E + 2 , AX
	LEA AX,ISR_0E
	MOV DS:[ (4*14) + 0 ], AX		; LOAD NEW ISR 
	MOV DS:[ (4*14) + 2 ], CS
	
	LDS BX,CS:REQPTR			; GET BACK REQUEST HEADER
	
	MOV AL,[BX+22]				; GET DRIVE NUMBER
	ADD AL,'A'				; NOW DRIVE LETTER
	MOV CS:DRVL,AL				; SAVE IT
	
	MOV CS:PH_DISK,0
	LES DI,[BX+18]				; COMMAND LINE
CD01:	CMP BYTE PTR ES:[DI],0
	JZ CD05
	CMP BYTE PTR ES:[DI],13
	JZ CD05
	CMP BYTE PTR ES:[DI],10
	JZ CD05
	CMP WORD PTR ES:[DI],'A/'
	JZ CD03
	CMP WORD PTR ES:[DI],'B/'
	JZ CD03
	CMP WORD PTR ES:[DI],'a/'
	JZ CD03
	CMP WORD PTR ES:[DI],'b/'
	JZ CD03
	INC DI
	JMP CD01
CD03:	INC DI
	MOV AL,ES:[DI]
	AND AL,1
	NOT AL
	AND AL,1
	MOV CS:PH_DISK,AL
CD05:	
	MOV AL,CS:PH_DISK
	ADD AL,'A'
	MOV CS:PDRIVE,AL

	MOV BYTE PTR [BX+13],1			; # OF BLOCK DEVICES
	LEA AX,DGROUP:END_OF_DRV
        MOV [BX+14],AX
	MOV [BX+16],CS				; END OF DEVICE DRIVER
	LEA AX,BPB_PTR
	MOV [BX+18],AX
	MOV [BX+20],CS				; PTR TO BPB
	;MOV BYTE PTR [BX+19H],0		; physical drive number
	LEA SI,INIT_MSG
	PUSH BX
PR01:	MOV AL,CS:[SI]
	INC SI
	MOV BX,7
	MOV AH,0EH
	INT 10H
	CMP AL,0
	JNZ PR01	
	POP BX
	JMP EXIT				; INIT COMPLETE

;	
;	۱۱ CALL INT 13 WITH RETRY IF THERE IS A ERROR ۱۱
;	

BIOS13 PROC
	MOV CS:RTY1,3
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	
B13A:	POP DX
	POP CX
	POP BX
	POP AX
	
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	
	INT 13H
	JNC B13_OK
	MOV DL,CS:PH_DISK
	XOR AX,AX
	INT 13H
	DEC CS:RTY1
	CMP CS:RTY1,0
	JNZ B13A
	ADD SP,(2*4)	
	STC
	RET

B13_OK:	
	ADD SP,(2*4)
	CLC
	RET

BIOS13 ENDP

;
; INTERRUPT HANDELER OF IRQ 6 (int 0EH) FLOPPY DISK EVENT 
;
ISR_0E	PROC
		PUSHF
		DB 09AH			; CALL FAR    OLD HANDLER
OLD_ISR_0E 	DD ?			; FAR  PTR OF OLD HANDLER 
		PUSHF
		PUSH AX
		PUSH DS

		MOV AX,40H
		MOV DS,AX
		MOV AL,DS:[42H]		; STATUS  REG #0 OF DISKETE CONTROLER
		AND AL,11000000B
		CMP AL,11000000B	; IS CHANGE LINE ACTIVE
		JNZ GFG1
		MOV CS:IS_VALID_BUFF,0	; INVALIDATE LOCAL BOOT BUFF
		MOV CS:IS_M_CH,0	; MEDIA IS REMOVED, BUT MAY NOT BE
					; CHANGED
		
GFG1:		POP DS
		POP AX
		POPF
		IRET
ISR_0E ENDP

;
; DOS COMMAND PROMPT ENTRY POINT ( UN USEFUL) 
;
MAIN PROC
	PUSH CS
	POP DS
	LEA DX,DGROUP:_MSG1
	MOV AH,09H
	INT 21H
	MOV AH,4CH
	INT 21H


MAIN ENDP

DRIVER ENDS
;۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱
; END OF THE DEVICE DRIVER CODE 
;۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱۱


;
; ACTUALL BOOT SECTOR THAT MUST BE ON DISK 
;
INCLUDE		FSA_BOOT.INC

;
; DEVICE DRIVER LOCAL DATA - VIRTUAL SEGMENT 
;
MYDATA SEGMENT 'DATA'

FNPTR   LABEL WORD 	; ARRAY OF POINTER TO FUNCTION 
 	DW INIT		;0
	DW MEDIA_CHK	;1
	DW BUILDBPB	;2
	DW CMDERR	;3
	DW MOVE_BLOCK	;4
	DW EXIT		;5
	DW EXIT		;6
	DW EXIT		;7
	DW MOVE_BLOCK	;8
	DW MOVE_BLOCK	;9
	DW EXIT		;10
	DW EXIT		;11
	DW CMDERR	;12
	DW EXIT		;13
	DW EXIT		;14
	DW EXIT		;15
	DW EXIT		
	DW EXIT		
	DW EXIT		
	;
DRVBPB	DW	512	;SECT SIZE
	DB	1	; SECT/CLUST
	DW	1	; # BOOT SECT
	DB	2	; # FAT
	DW	224	; DIRS
	DW	2880	; TOTAL SECT
	DB	0F0H	; MEDIA
	DW	9	; #  SECT / FAT
	DW	18	; SECT /TRK
	DW	2	; HEADS
	;
	PH_DISK		DB 0
	LAST_ACSS	LABEL WORD
			DD 0,0
	RTY1		DB 0
	IS_VALID_BUFF	DB 0	; FLAG THAT DETERMINE THAT IF LOCAL BOOT 
				; BOOT BUFF CONTAINING VALID DATA
				; 0 = INVALID , !0 = VALID
	IS_M_CH		DB 55H	
	SYS_SECT	DW 0H
	DSK_BOOT 	DW 0H
	OLD_SRN		DD -1
	BPB_PTR		DW DRVBPB
	NEW_BPB 	DW DRVBPB
	REQPTR		DD ?
	BOOT_BUFF	DB  53 DUP (' BOOT_BUFF')	; MUST BE 10 CHARS
			DB 100 DUP ('STACK')		; MUST BE  5 CHARS
	LOCAL_STACK	DW ?
	CALLER_STACK	DD ?
	PR_VOL_ID	DB 'NO NAME',0,0,0,0,0,0
			DB 'END OF DEVICE DRIVER'
	END_OF_DRV	DB 0	

	_MSG1		DB 13,10,'Block Device Driver For Fisa Disk Format .',13,10
			DB 13,10,'Install It From Config.sys with Device Command.'
			DB 13,10,'Syntax  Device=Fisa_drv.exe  [ /A | /B ] .'
			DB 13,10,'Where [ /A | /B ] is Physical Drive . Default is  /A  .'
			DB 13,10,'Writter Asif Khan Suri from [ FAST ICS KARACHI ] '
			DB 13,10,'Foundation For Advancement Science and Technology.'
			Db 13,10,'$$$'

	INIT_MSG	DB 13,10,13,10,'  Device Driver For [ Fisa ] Disk Format'
			db             ' Initilized Succusfully. '
			db 13,10,      '  Writter Asif Khan Suri. [ FAST ICS KARACHI ]'
			db 13,10,      '  Physical Drive is [ '
	PDRIVE		db ?
			DB ': ].  Disk will Accessed as Drive [ '
	DRVL		DB ?
			db ': ] ',13,10,0,0
MYDATA ENDS

; GAME OVER 
END MAIN

			


